Liblinphone: linphone::AccountParams Class Reference

Liblinphone 5.3.0

Public Member Functions | Static Public Member Functions | List of all members
linphone::AccountParams Class Reference

Object that is used to set the different parameters of a Account. More...

`#include <account_params.hh>`

Inheritance diagram for linphone::AccountParams:

## Public Member Functions
LINPHONECXX_PUBLIC | AccountParams (void *ptr, bool takeRef=true)
LINPHONECXX_PUBLIC _LinphoneAccountParams * | cPtr ()
LINPHONECXX_PUBLIC std::shared_ptr< const linphone::Address > | getAudioVideoConferenceFactoryAddress () const
| Get the audio video conference factory uri.
LINPHONECXX_PUBLIC void | setAudioVideoConferenceFactoryAddress (const std::shared_ptr< const linphone::Address > &address)
| Set the audio video conference factory uri.
LINPHONECXX_PUBLIC linphone::AVPFMode | getAvpfMode () const
| Get enablement status of RTCP feedback (also known as AVPF profile).
LINPHONECXX_PUBLIC void | setAvpfMode (linphone::AVPFMode mode)
| Enable the use of RTCP feedback (also known as AVPF profile).
LINPHONECXX_PUBLIC uint8_t | getAvpfRrInterval () const
| Get the interval between regular RTCP reports when using AVPF/SAVPF.
LINPHONECXX_PUBLIC void | setAvpfRrInterval (uint8_t interval)
| Set the interval between regular RTCP reports when using AVPF/SAVPF.
LINPHONECXX_PUBLIC std::shared_ptr< const linphone::Address > | getConferenceFactoryAddress () const
| Get the conference factory uri.
LINPHONECXX_PUBLIC void | setConferenceFactoryAddress (const std::shared_ptr< const linphone::Address > &address)
| Set the conference factory uri.
LINPHONECXX_PUBLIC std::string | getConferenceFactoryUri () const
| Get the conference factory uri.
LINPHONECXX_PUBLIC LINPHONECXX_DEPRECATED void | setConferenceFactoryUri (const std::string &uri)
| Set the conference factory uri.
LINPHONECXX_PUBLIC std::string | getContactParameters () const
| Returns the contact parameters.
LINPHONECXX_PUBLIC void | setContactParameters (const std::string &contactParams)
| Set optional contact parameters that will be added to the contact information sent in the registration.
LINPHONECXX_PUBLIC std::string | getContactUriParameters () const
| Return the contact URI parameters.
LINPHONECXX_PUBLIC void | setContactUriParameters (const std::string &contactUriParams)
| Set optional contact parameters that will be added to the contact information sent in the registration, inside the URI.
LINPHONECXX_PUBLIC bool | cpimInBasicChatRoomEnabled () const
| Indicates whether chat messages sent by this account in a ChatRoom::Backend::Basic chat room will be using CPIM format or not.
LINPHONECXX_PUBLIC void | enableCpimInBasicChatRoom (bool enable)
| Indicates whether chat messages sent by this account in a ChatRoom::Backend::Basic chat room will be using CPIM format or not.
LINPHONECXX_PUBLIC std::shared_ptr< const linphone::Address > | getCustomContact () const
| Get the custom contact address previously used when registering to the SIP server.
LINPHONECXX_PUBLIC void | setCustomContact (const std::shared_ptr< linphone::Address > &contact)
| Set a an optional custom contact address to be used when registering to the SIP server.
LINPHONECXX_PUBLIC bool | dialEscapePlusEnabled () const
| Return whether or not the + should be replaced by 00.
LINPHONECXX_PUBLIC void | enableDialEscapePlus (bool enable)
| Set whether liblinphone should replace "+" by international calling prefix in dialed numbers (passed to linphone_core_invite).
LINPHONECXX_PUBLIC std::string | getDomain () const
| Get the domain name of the given account params.
LINPHONECXX_PUBLIC int | getExpires () const
| Get the account params expires.
LINPHONECXX_PUBLIC void | setExpires (int expires)
| Sets the registration expiration time in seconds.
LINPHONECXX_PUBLIC LINPHONECXX_DEPRECATED std::string | getIdentity () const
| Get the identity of the account params.
LINPHONECXX_PUBLIC std::shared_ptr< const linphone::Address > | getIdentityAddress () const
| Get the identity address of the account params.
LINPHONECXX_PUBLIC linphone::Status | setIdentityAddress (const std::shared_ptr< linphone::Address > &identity)
| Sets the user identity as a SIP address.
LINPHONECXX_PUBLIC std::string | getIdkey () const
| Get the idkey property of a AccountParams.
LINPHONECXX_PUBLIC void | setIdkey (const std::string &idkey)
| Set the idkey property on the given account params.
LINPHONECXX_PUBLIC std::string | getInternationalPrefix () const
| Get the prefix set for this account params.
LINPHONECXX_PUBLIC void | setInternationalPrefix (const std::string &prefix)
| Set an international prefix to be automatically prepended when inviting a number with Core::invite(); This international prefix shall usually be the country code of the country where the user is living, without "+".
LINPHONECXX_PUBLIC bool | isPushNotificationAvailable () const
| Gets whether push notifications are available or not (Android & iOS only).
LINPHONECXX_PUBLIC std::string | getLimeServerUrl () const
| Get the x3dh server url.
LINPHONECXX_PUBLIC void | setLimeServerUrl (const std::string &url)
| Set the x3dh server url.
LINPHONECXX_PUBLIC std::shared_ptr< linphone::NatPolicy > | getNatPolicy () const
| Get The policy that is used to pass through NATs/firewalls when using this account params.
LINPHONECXX_PUBLIC void | setNatPolicy (const std::shared_ptr< linphone::NatPolicy > &policy)
| Set the policy to use to pass through NATs/firewalls when using this account params.
LINPHONECXX_PUBLIC bool | outboundProxyEnabled () const
| Tell if the proxy is used as the only route.
LINPHONECXX_PUBLIC void | enableOutboundProxy (bool enable)
| If enabled, the proxy will be used as the only route.
LINPHONECXX_PUBLIC std::string | getPictureUri () const
| Gets the account picture URI if set, nullptr otherwise.
LINPHONECXX_PUBLIC void | setPictureUri (const std::string &uri)
| Sets an URI for the account picture.
LINPHONECXX_PUBLIC unsigned int | getPrivacy () const
| Get default privacy policy for all calls routed through this proxy.
LINPHONECXX_PUBLIC void | setPrivacy (unsigned int privacy)
| Set default privacy policy for all calls routed through this proxy.
LINPHONECXX_PUBLIC bool | publishEnabled () const
| Tell if the PUBLISH is enabled.
LINPHONECXX_PUBLIC void | enablePublish (bool enable)
| Indicates either or not, PUBLISH must be issued for this AccountParams.
LINPHONECXX_PUBLIC int | getPublishExpires () const
| Get the publish expiration time in second.
LINPHONECXX_PUBLIC void | setPublishExpires (int expires)
| Set the publish expiration time in second.
LINPHONECXX_PUBLIC bool | getPushNotificationAllowed () const
| Indicates whether to add to the contact parameters the push notification information.
LINPHONECXX_PUBLIC void | setPushNotificationAllowed (bool allow)
| Indicates whether to add to the contact parameters the push notification information.
LINPHONECXX_PUBLIC std::shared_ptr< linphone::PushNotificationConfig > | getPushNotificationConfig () const
| Returns the push notification configuration.
LINPHONECXX_PUBLIC void | setPushNotificationConfig (const std::shared_ptr< linphone::PushNotificationConfig > &config)
| Sets the push notification configuration.
LINPHONECXX_PUBLIC std::string | getQualityReportingCollector () const
| Get the route of the collector end-point when using quality reporting.
LINPHONECXX_PUBLIC void | setQualityReportingCollector (const std::string &collector)
| Set the route of the collector end-point when using quality reporting.
LINPHONECXX_PUBLIC bool | qualityReportingEnabled () const
| Indicates whether quality statistics during call should be stored and sent to a collector according to RFC 6035.
LINPHONECXX_PUBLIC void | enableQualityReporting (bool enable)
| Indicates whether quality statistics during call should be stored and sent to a collector according to RFC 6035.
LINPHONECXX_PUBLIC int | getQualityReportingInterval () const
| Get the interval between interval reports when using quality reporting.
LINPHONECXX_PUBLIC void | setQualityReportingInterval (int interval)
| Set the interval between 2 interval reports sending when using quality reporting.
LINPHONECXX_PUBLIC std::string | getRealm () const
| Get the realm of the given account params.
LINPHONECXX_PUBLIC void | setRealm (const std::string &realm)
| Set the realm of the given account params.
LINPHONECXX_PUBLIC std::string | getRefKey () const
| Get the persistent reference key associated to the account params.
LINPHONECXX_PUBLIC void | setRefKey (const std::string &refkey)
| Associate a persistent reference key to the account params.
LINPHONECXX_PUBLIC bool | registerEnabled () const
| Returns whether the account params is enabled or not.
LINPHONECXX_PUBLIC void | enableRegister (bool enable)
| Indicates either or not, REGISTRATION must be issued for this AccountParams.
LINPHONECXX_PUBLIC bool | getRemotePushNotificationAllowed () const
| Indicates whether to add to the contact parameters the push notification information.
LINPHONECXX_PUBLIC void | setRemotePushNotificationAllowed (bool allow)
| Indicates whether to add to the contact parameters the push notification information.
LINPHONECXX_PUBLIC std::list< std::shared_ptr< linphone::Address > > | getRoutesAddresses () const
| Gets the list of the routes set for this account params.
LINPHONECXX_PUBLIC linphone::Status | setRoutesAddresses (const std::list< std::shared_ptr< linphone::Address > > &routes)
| Sets a list of SIP route.
LINPHONECXX_PUBLIC bool | rtpBundleAssumptionEnabled () const
| Returns whether RTP bundle mode is assumed.
LINPHONECXX_PUBLIC void | enableRtpBundleAssumption (bool value)
| Indicates whether support of rtp bundle is assumed.
LINPHONECXX_PUBLIC bool | rtpBundleEnabled () const
| Returns whether RTP bundle mode (also known as Media Multiplexing) is enabled.
LINPHONECXX_PUBLIC void | enableRtpBundle (bool value)
| Enables or disables RTP bundle mode (Media Multiplexing).
LINPHONECXX_PUBLIC LINPHONECXX_DEPRECATED std::string | getServerAddr () const
| Get the account params proxy address.
LINPHONECXX_PUBLIC LINPHONECXX_DEPRECATED linphone::Status | setServerAddr (const std::string &serverAddress)
| Sets the proxy address.
LINPHONECXX_PUBLIC std::shared_ptr< const linphone::Address > | getServerAddress () const
| Get the account params proxy address.
LINPHONECXX_PUBLIC linphone::Status | setServerAddress (const std::shared_ptr< linphone::Address > &serverAddress)
| Sets the proxy address.
LINPHONECXX_PUBLIC linphone::TransportType | getTransport () const
| Returns the transport type of the server address.
LINPHONECXX_PUBLIC void | setTransport (linphone::TransportType transport)
| Sets the transport type of the server address.
LINPHONECXX_PUBLIC bool | getUseInternationalPrefixForCallsAndChats () const
| Return whether or not the international prefix will automaticaly be used for calls and chats.
LINPHONECXX_PUBLIC void | setUseInternationalPrefixForCallsAndChats (bool enable)
| If enabled, the international prefix will automaticaly be used for calls and chats.
LINPHONECXX_PUBLIC void | addCustomParam (const std::string &key, const std::string &value)
| Set one custom parameter to this AccountParams.
LINPHONECXX_PUBLIC std::shared_ptr< linphone::AccountParams > | clone () const
| Instantiate a new account params with values from source.
LINPHONECXX_PUBLIC std::string | getCustomParam (const std::string &key) const
| Get the custom parameter with key to this AccountParams.

## Static Public Member Functions
static LINPHONECXX_PUBLIC std::shared_ptr< linphone::AccountParams > | newWithConfig (const std::shared_ptr< linphone::Core > &lc, int index)
| Create a new AccountParams object from a configuration.

## Detailed Description

Object that is used to set the different parameters of a Account.

Note that authenticated accounts should have a corresponding AuthInfo added to the Core to register properly.

## Member Function Documentation

## ◆ addCustomParam()

LINPHONECXX_PUBLIC void linphone::AccountParams::addCustomParam | ( | const std::string & | key,
|  | const std::string & | value )

Set one custom parameter to this AccountParams.

Parameters

  key | key of the searched parameter.
  value | value of the searched parameter.

## ◆ clone()

LINPHONECXX_PUBLIC std::shared_ptr< linphone::AccountParams > linphone::AccountParams::clone | ( |  | ) | const

Instantiate a new account params with values from source.

Returns
  The newly created AccountParams object.

## ◆ cpimInBasicChatRoomEnabled()

LINPHONECXX_PUBLIC bool linphone::AccountParams::cpimInBasicChatRoomEnabled | ( |  | ) | const

Indicates whether chat messages sent by this account in a ChatRoom::Backend::Basic chat room will be using CPIM format or not.

By default SIP SIMPLE format is used for "basic" chat rooms, CPIM is only used for ChatRoom::Backend::FlexisipChat chat rooms.

See also
  https://wiki.linphone.org/xwiki/wiki/public/view/Lib/Features/Instant%20Messaging/Reply%20to%20a%20specific%20message/

Returns
  true if chat messages will be sent out in CPIM format, false if chat messages will be sent out as SIP SIMPLE.

## ◆ dialEscapePlusEnabled()

LINPHONECXX_PUBLIC bool linphone::AccountParams::dialEscapePlusEnabled | ( |  | ) | const

Return whether or not the + should be replaced by 00.

Returns
  Whether liblinphone should replace "+" by "00" in dialed numbers (passed to Core::invite()).

## ◆ enableCpimInBasicChatRoom()

LINPHONECXX_PUBLIC void linphone::AccountParams::enableCpimInBasicChatRoom | ( | bool | enable | ) |

Indicates whether chat messages sent by this account in a ChatRoom::Backend::Basic chat room will be using CPIM format or not.

Parameters

  enable | true to send messages in CPIM format, false to keep using the SIP SIMPLE format.

## ◆ enableDialEscapePlus()

LINPHONECXX_PUBLIC void linphone::AccountParams::enableDialEscapePlus | ( | bool | enable | ) |

Set whether liblinphone should replace "+" by international calling prefix in dialed numbers (passed to linphone_core_invite).

Parameters

  enable | true to replace + by the international prefix, false otherwise.

## ◆ enableOutboundProxy()

LINPHONECXX_PUBLIC void linphone::AccountParams::enableOutboundProxy | ( | bool | enable | ) |

If enabled, the proxy will be used as the only route.

Parameters

  enable | true to enable, false otherwise.

## ◆ enablePublish()

LINPHONECXX_PUBLIC void linphone::AccountParams::enablePublish | ( | bool | enable | ) |

Indicates either or not, PUBLISH must be issued for this AccountParams.

Parameters

  enable | If true, publish will be engaged.

## ◆ enableQualityReporting()

LINPHONECXX_PUBLIC void linphone::AccountParams::enableQualityReporting | ( | bool | enable | ) |

Indicates whether quality statistics during call should be stored and sent to a collector according to RFC 6035.

Parameters

  enable | true to store quality statistics and send them to the collector, false to disable it.

## ◆ enableRegister()

LINPHONECXX_PUBLIC void linphone::AccountParams::enableRegister | ( | bool | enable | ) |

Indicates either or not, REGISTRATION must be issued for this AccountParams.

Parameters

  enable | If true, registration will be engaged.

## ◆ enableRtpBundle()

LINPHONECXX_PUBLIC void linphone::AccountParams::enableRtpBundle | ( | bool | value | ) |

Enables or disables RTP bundle mode (Media Multiplexing).

See https://datatracker.ietf.org/doc/html/rfc8843 for more information about the feature. When enabled, liblinphone will try to negociate the use of a single port for all streams when doing an outgoing call. It automatically enables rtcp-mux.

Parameters

  value | a boolean to indicate whether the feature is to be enabled.

## ◆ enableRtpBundleAssumption()

LINPHONECXX_PUBLIC void linphone::AccountParams::enableRtpBundleAssumption | ( | bool | value | ) |

Indicates whether support of rtp bundle is assumed.

See enableRtpBundle() for background information about rtp bundle. Assumption that RTP bundling support allows interesting optimizations, such as not gathering RTCP candidates, and not gathering candidates for video stream when making an outgoing call. This setting is meaningful only if rtp bundle is enabled. See https://datatracker.ietf.org/doc/html/rfc8843 for more information about the feature.

Parameters

  value | a boolean to indicate whether RTP bundle support can be assumed.

## ◆ getAudioVideoConferenceFactoryAddress()

LINPHONECXX_PUBLIC std::shared_ptr< const linphone::Address > linphone::AccountParams::getAudioVideoConferenceFactoryAddress | ( |  | ) | const

Get the audio video conference factory uri.

Returns
  The Address of the audio video conference factory.

## ◆ getAvpfMode()

LINPHONECXX_PUBLIC linphone::AVPFMode linphone::AccountParams::getAvpfMode | ( |  | ) | const

Get enablement status of RTCP feedback (also known as AVPF profile).

Returns
  the enablement mode, which can be AVPFMode::Default (use Core's mode), AVPFMode::Enabled (avpf is enabled), or AVPFMode::Disabled (disabled).

## ◆ getAvpfRrInterval()

LINPHONECXX_PUBLIC uint8_t linphone::AccountParams::getAvpfRrInterval | ( |  | ) | const

Get the interval between regular RTCP reports when using AVPF/SAVPF.

Returns
  The interval in seconds.

## ◆ getConferenceFactoryAddress()

LINPHONECXX_PUBLIC std::shared_ptr< const linphone::Address > linphone::AccountParams::getConferenceFactoryAddress | ( |  | ) | const

Get the conference factory uri.

Returns
  The Address of the conference factory.

## ◆ getConferenceFactoryUri()

LINPHONECXX_PUBLIC std::string linphone::AccountParams::getConferenceFactoryUri | ( |  | ) | const

Get the conference factory uri.

Returns
  The uri of the conference factory.

## ◆ getContactParameters()

LINPHONECXX_PUBLIC std::string linphone::AccountParams::getContactParameters | ( |  | ) | const

Returns the contact parameters.

Returns
  The previously set contact parameters.

## ◆ getContactUriParameters()

LINPHONECXX_PUBLIC std::string linphone::AccountParams::getContactUriParameters | ( |  | ) | const

Return the contact URI parameters.

Returns
  The previously set contact URI parameters.

## ◆ getCustomContact()

LINPHONECXX_PUBLIC std::shared_ptr< const linphone::Address > linphone::AccountParams::getCustomContact | ( |  | ) | const

Get the custom contact address previously used when registering to the SIP server.

Returns
  a Address

## ◆ getCustomParam()

LINPHONECXX_PUBLIC std::string linphone::AccountParams::getCustomParam | ( | const std::string & | key | ) | const

Get the custom parameter with key to this AccountParams.

Parameters

  key | key of the searched parameter.

Returns
  The value of the parameter with key if found or an empty string otherwise.

## ◆ getDomain()

LINPHONECXX_PUBLIC std::string linphone::AccountParams::getDomain | ( |  | ) | const

Get the domain name of the given account params.

Returns
  The domain name of the account params.

## ◆ getExpires()

LINPHONECXX_PUBLIC int linphone::AccountParams::getExpires | ( |  | ) | const

Get the account params expires.

Returns
  The duration of registration.

## ◆ getIdentity()

LINPHONECXX_PUBLIC LINPHONECXX_DEPRECATED std::string linphone::AccountParams::getIdentity | ( |  | ) | const

Get the identity of the account params.

Returns
  The SIP identity that belongs to this account params.

Deprecated
  01/03/2021 Use getIdentityAddress() instead.

## ◆ getIdentityAddress()

LINPHONECXX_PUBLIC std::shared_ptr< const linphone::Address > linphone::AccountParams::getIdentityAddress | ( |  | ) | const

Get the identity address of the account params.

Returns
  The SIP identity that belongs to this account params.

## ◆ getIdkey()

LINPHONECXX_PUBLIC std::string linphone::AccountParams::getIdkey | ( |  | ) | const

Get the idkey property of a AccountParams.

Returns
  The idkey string, or nullptr.

## ◆ getInternationalPrefix()

LINPHONECXX_PUBLIC std::string linphone::AccountParams::getInternationalPrefix | ( |  | ) | const

Get the prefix set for this account params.

Returns
  The international prefix.

## ◆ getLimeServerUrl()

LINPHONECXX_PUBLIC std::string linphone::AccountParams::getLimeServerUrl | ( |  | ) | const

Get the x3dh server url.

Returns
  The x3dh server url.

## ◆ getNatPolicy()

LINPHONECXX_PUBLIC std::shared_ptr< linphone::NatPolicy > linphone::AccountParams::getNatPolicy | ( |  | ) | const

Get The policy that is used to pass through NATs/firewalls when using this account params.

If it is set to nullptr, the default NAT policy from the core will be used instead.

Returns
  The NatPolicy object in use.

See also
  Core::getNatPolicy()

## ◆ getPictureUri()

LINPHONECXX_PUBLIC std::string linphone::AccountParams::getPictureUri | ( |  | ) | const

Gets the account picture URI if set, nullptr otherwise.

Returns
  The account picture URI.

## ◆ getPrivacy()

LINPHONECXX_PUBLIC unsigned int linphone::AccountParams::getPrivacy | ( |  | ) | const

Get default privacy policy for all calls routed through this proxy.

Returns
  Privacy mode as LinphonePrivacyMask

## ◆ getPublishExpires()

LINPHONECXX_PUBLIC int linphone::AccountParams::getPublishExpires | ( |  | ) | const

Get the publish expiration time in second.

Default value is the registration expiration value.

Returns
  The expire time in seconds.

## ◆ getPushNotificationAllowed()

LINPHONECXX_PUBLIC bool linphone::AccountParams::getPushNotificationAllowed | ( |  | ) | const

Indicates whether to add to the contact parameters the push notification information.

For IOS, it indicates for VOIP push notification.

Returns
  true if push notification informations should be added, false otherwise.

## ◆ getPushNotificationConfig()

LINPHONECXX_PUBLIC std::shared_ptr< linphone::PushNotificationConfig > linphone::AccountParams::getPushNotificationConfig | ( |  | ) | const

Returns the push notification configuration.

Returns
  The PushNotificationConfig object.

## ◆ getQualityReportingCollector()

LINPHONECXX_PUBLIC std::string linphone::AccountParams::getQualityReportingCollector | ( |  | ) | const

Get the route of the collector end-point when using quality reporting.

This SIP address should be used on server-side to process packets directly before discarding packets. Collector address should be a non existing account and will not receive any messages. If nullptr, reports will be send to the proxy domain.

Returns
  The SIP address of the collector end-point.

## ◆ getQualityReportingInterval()

LINPHONECXX_PUBLIC int linphone::AccountParams::getQualityReportingInterval | ( |  | ) | const

Get the interval between interval reports when using quality reporting.

Returns
  The interval in seconds, 0 means interval reports are disabled.

## ◆ getRealm()

LINPHONECXX_PUBLIC std::string linphone::AccountParams::getRealm | ( |  | ) | const

Get the realm of the given account params.

Returns
  The realm of the account params.

## ◆ getRefKey()

LINPHONECXX_PUBLIC std::string linphone::AccountParams::getRefKey | ( |  | ) | const

Get the persistent reference key associated to the account params.

The reference key can be for example an id to an external database. It is stored in the config file, thus can survive to process exits/restarts.

Returns
  The reference key string that has been associated to the account params, or nullptr if none has been associated.

## ◆ getRemotePushNotificationAllowed()

LINPHONECXX_PUBLIC bool linphone::AccountParams::getRemotePushNotificationAllowed | ( |  | ) | const

Indicates whether to add to the contact parameters the push notification information.

Returns
  true if remote push notification informations should be added, false otherwise.

## ◆ getRoutesAddresses()

LINPHONECXX_PUBLIC std::list< std::shared_ptr< linphone::Address > > linphone::AccountParams::getRoutesAddresses | ( |  | ) | const

Gets the list of the routes set for this account params.

Warning
  If linphone_account_params_is_outbound_proxy_enabled is true then it will only return the proxy address.

Returns
  The list of routes.

## ◆ getServerAddr()

LINPHONECXX_PUBLIC LINPHONECXX_DEPRECATED std::string linphone::AccountParams::getServerAddr | ( |  | ) | const

Get the account params proxy address.

Returns
  The proxy's SIP address.

Deprecated
  01/03/2021 Use getServerAddress() instead.

## ◆ getServerAddress()

LINPHONECXX_PUBLIC std::shared_ptr< const linphone::Address > linphone::AccountParams::getServerAddress | ( |  | ) | const

Get the account params proxy address.

Returns
  The proxy's SIP Address.

## ◆ getTransport()

LINPHONECXX_PUBLIC linphone::TransportType linphone::AccountParams::getTransport | ( |  | ) | const

Returns the transport type of the server address.

Returns
  The TransportType of the server address.

## ◆ getUseInternationalPrefixForCallsAndChats()

LINPHONECXX_PUBLIC bool linphone::AccountParams::getUseInternationalPrefixForCallsAndChats | ( |  | ) | const

Return whether or not the international prefix will automaticaly be used for calls and chats.

Returns
  Whether we should use international prefix automatically for calls.

## ◆ isPushNotificationAvailable()

LINPHONECXX_PUBLIC bool linphone::AccountParams::isPushNotificationAvailable | ( |  | ) | const

Gets whether push notifications are available or not (Android & iOS only).

Returns
  true if push notifications are available, false otherwise

## ◆ newWithConfig()

LINPHONECXX_PUBLIC std::shared_ptr< linphone::AccountParams > linphone::AccountParams::newWithConfig | ( | const std::shared_ptr< linphone::Core > & | lc,
|  | int | index )
| static

Create a new AccountParams object from a configuration.

Parameters

  lc | The Core object.
  index | The index of the configuration.

Returns
  The newly created AccountParams object.

## ◆ outboundProxyEnabled()

LINPHONECXX_PUBLIC bool linphone::AccountParams::outboundProxyEnabled | ( |  | ) | const

Tell if the proxy is used as the only route.

Returns
  enable true if enabled, false otherwise.

## ◆ publishEnabled()

LINPHONECXX_PUBLIC bool linphone::AccountParams::publishEnabled | ( |  | ) | const

Tell if the PUBLISH is enabled.

Returns
  true if PUBLISH request is enabled for this proxy.

## ◆ qualityReportingEnabled()

LINPHONECXX_PUBLIC bool linphone::AccountParams::qualityReportingEnabled | ( |  | ) | const

Indicates whether quality statistics during call should be stored and sent to a collector according to RFC 6035.

Returns
  true if quality repotring is enabled, false otherwise.

## ◆ registerEnabled()

LINPHONECXX_PUBLIC bool linphone::AccountParams::registerEnabled | ( |  | ) | const

Returns whether the account params is enabled or not.

Returns
  true if registration to the proxy is enabled.

## ◆ rtpBundleAssumptionEnabled()

LINPHONECXX_PUBLIC bool linphone::AccountParams::rtpBundleAssumptionEnabled | ( |  | ) | const

Returns whether RTP bundle mode is assumed.

See https://datatracker.ietf.org/doc/html/rfc8843 for more information.

Returns
  a boolean indicating when rtp bundle support is assumed.

## ◆ rtpBundleEnabled()

LINPHONECXX_PUBLIC bool linphone::AccountParams::rtpBundleEnabled | ( |  | ) | const

Returns whether RTP bundle mode (also known as Media Multiplexing) is enabled.

See https://datatracker.ietf.org/doc/html/rfc8843 for more information.

Returns
  a boolean indicating the enablement of rtp bundle mode.

## ◆ setAudioVideoConferenceFactoryAddress()

LINPHONECXX_PUBLIC void linphone::AccountParams::setAudioVideoConferenceFactoryAddress | ( | const std::shared_ptr< const linphone::Address > & | address | ) |

Set the audio video conference factory uri.

Parameters

  address | The Address to set.

## ◆ setAvpfMode()

LINPHONECXX_PUBLIC void linphone::AccountParams::setAvpfMode | ( | linphone::AVPFMode | mode | ) |

Enable the use of RTCP feedback (also known as AVPF profile).

Parameters

  mode | the enablement mode, which can be AVPFMode::Default (use Core's mode), AVPFMode::Enabled (avpf is enabled), or AVPFMode::Disabled (disabled).

## ◆ setAvpfRrInterval()

LINPHONECXX_PUBLIC void linphone::AccountParams::setAvpfRrInterval | ( | uint8_t | interval | ) |

Set the interval between regular RTCP reports when using AVPF/SAVPF.

Parameters

  interval | The interval in seconds (between 0 and 5 seconds).

## ◆ setConferenceFactoryAddress()

LINPHONECXX_PUBLIC void linphone::AccountParams::setConferenceFactoryAddress | ( | const std::shared_ptr< const linphone::Address > & | address | ) |

Set the conference factory uri.

Parameters

  address | The Address to set.

## ◆ setConferenceFactoryUri()

LINPHONECXX_PUBLIC LINPHONECXX_DEPRECATED void linphone::AccountParams::setConferenceFactoryUri | ( | const std::string & | uri | ) |

Set the conference factory uri.

Parameters

  uri | The uri of the conference factory.

Deprecated
  16/08/2023 Use setConferenceFactoryAddress() instead.

## ◆ setContactParameters()

LINPHONECXX_PUBLIC void linphone::AccountParams::setContactParameters | ( | const std::string & | contactParams | ) |

Set optional contact parameters that will be added to the contact information sent in the registration.

Parameters

  contactParams | A string contaning the additional parameters in text form, like "myparam=something;myparam2=something_else" The main use case for this function is provide the proxy additional information regarding the user agent, like for example unique identifier or apple push id. As an example, the contact address in the SIP register sent will look like <sip:joe@1.nosp@m.5.12.nosp@m.8.128.nosp@m..93:50421>;apple-push-id=43143-DFE23F-2323-FA2232.

## ◆ setContactUriParameters()

LINPHONECXX_PUBLIC void linphone::AccountParams::setContactUriParameters | ( | const std::string & | contactUriParams | ) |

Set optional contact parameters that will be added to the contact information sent in the registration, inside the URI.

Parameters

  contactUriParams | A string containing the additional parameters in text form, like "myparam=something;myparam2=something_else" The main use case for this function is provide the proxy additional information regarding the user agent, like for example unique identifier or apple push id. As an example, the contact address in the SIP register sent will look like <sip:joe@1.nosp@m.5.12.nosp@m.8.128.nosp@m..93:50421;apple-push-id=43143-DFE23F-2323-FA2232>.

## ◆ setCustomContact()

LINPHONECXX_PUBLIC void linphone::AccountParams::setCustomContact | ( | const std::shared_ptr< linphone::Address > & | contact | ) |

Set a an optional custom contact address to be used when registering to the SIP server.

This is typically used to supply an alternative SIP address to call in case the main one is not reachable.

Parameters

  contact | a Address the optional alternative contact address.

## ◆ setExpires()

LINPHONECXX_PUBLIC void linphone::AccountParams::setExpires | ( | int | expires | ) |

Sets the registration expiration time in seconds.

Parameters

  expires | The expiration time to set.

## ◆ setIdentityAddress()

LINPHONECXX_PUBLIC linphone::Status linphone::AccountParams::setIdentityAddress | ( | const std::shared_ptr< linphone::Address > & | identity | ) |

Sets the user identity as a SIP address.

This identity is normally formed with display name, username and domain, such as: Alice <sip:alice.nosp@m.@exa.nosp@m.mple..nosp@m.net> The REGISTER messages will have from and to set to this identity.

Parameters

  identity | The Address of the identity to set.

Returns
  0 if successful, -1 otherwise.

## ◆ setIdkey()

LINPHONECXX_PUBLIC void linphone::AccountParams::setIdkey | ( | const std::string & | idkey | ) |

Set the idkey property on the given account params.

This property can the be referenced by another account params 'depends_on' to create a dependency relation between them.

Parameters

  idkey | The idkey string to associate to the given AccountParams.

## ◆ setInternationalPrefix()

LINPHONECXX_PUBLIC void linphone::AccountParams::setInternationalPrefix | ( | const std::string & | prefix | ) |

Set an international prefix to be automatically prepended when inviting a number with Core::invite(); This international prefix shall usually be the country code of the country where the user is living, without "+".

Parameters

  prefix | The prefix to set (withouth the +).

## ◆ setLimeServerUrl()

LINPHONECXX_PUBLIC void linphone::AccountParams::setLimeServerUrl | ( | const std::string & | url | ) |

Set the x3dh server url.

If empty, this function will disable LIME X3DH from core. Otherwise, or if different from the existing value, this will (re-)initialize the LIME X3DH engine.

Parameters

  url | The x3dh server url.

## ◆ setNatPolicy()

LINPHONECXX_PUBLIC void linphone::AccountParams::setNatPolicy | ( | const std::shared_ptr< linphone::NatPolicy > & | policy | ) |

Set the policy to use to pass through NATs/firewalls when using this account params.

If it is set to nullptr, the default NAT policy from the core will be used instead.

Parameters

  policy | The NatPolicy object.

See also
  Core::setNatPolicy()

## ◆ setPictureUri()

LINPHONECXX_PUBLIC void linphone::AccountParams::setPictureUri | ( | const std::string & | uri | ) |

Sets an URI for the account picture.

Parameters

  uri | The account picture URI.

## ◆ setPrivacy()

LINPHONECXX_PUBLIC void linphone::AccountParams::setPrivacy | ( | unsigned int | privacy | ) |

Set default privacy policy for all calls routed through this proxy.

Parameters

  privacy | Privacy to configure privacy

## ◆ setPublishExpires()

LINPHONECXX_PUBLIC void linphone::AccountParams::setPublishExpires | ( | int | expires | ) |

Set the publish expiration time in second.

Parameters

  expires | The expire time in seconds.

## ◆ setPushNotificationAllowed()

LINPHONECXX_PUBLIC void linphone::AccountParams::setPushNotificationAllowed | ( | bool | allow | ) |

Indicates whether to add to the contact parameters the push notification information.

For IOS, it indicates for VOIP push notification.

Parameters

  allow | true to allow push notification information, false otherwise.

## ◆ setPushNotificationConfig()

LINPHONECXX_PUBLIC void linphone::AccountParams::setPushNotificationConfig | ( | const std::shared_ptr< linphone::PushNotificationConfig > & | config | ) |

Sets the push notification configuration.

Parameters

  config | The PushNotificationConfig object.

## ◆ setQualityReportingCollector()

LINPHONECXX_PUBLIC void linphone::AccountParams::setQualityReportingCollector | ( | const std::string & | collector | ) |

Set the route of the collector end-point when using quality reporting.

This SIP address should be used on server-side to process packets directly before discarding packets. Collector address should be a non existing account and will not receive any messages. If nullptr, reports will be send to the proxy domain.

Parameters

  collector | route of the collector end-point, if nullptr PUBLISH will be sent to the proxy domain.

## ◆ setQualityReportingInterval()

LINPHONECXX_PUBLIC void linphone::AccountParams::setQualityReportingInterval | ( | int | interval | ) |

Set the interval between 2 interval reports sending when using quality reporting.

If call exceed interval size, an interval report will be sent to the collector. On call termination, a session report will be sent for the remaining period. Value must be 0 (disabled) or positive.

Parameters

  interval | The interval in seconds, 0 means interval reports are disabled.

## ◆ setRealm()

LINPHONECXX_PUBLIC void linphone::AccountParams::setRealm | ( | const std::string & | realm | ) |

Set the realm of the given account params.

Parameters

  realm | New realm value.

## ◆ setRefKey()

LINPHONECXX_PUBLIC void linphone::AccountParams::setRefKey | ( | const std::string & | refkey | ) |

Associate a persistent reference key to the account params.

The reference key can be for example an id to an external database. It is stored in the config file, thus can survive to process exits/restarts.

Parameters

  refkey | The reference key string to associate to the account params.

## ◆ setRemotePushNotificationAllowed()

LINPHONECXX_PUBLIC void linphone::AccountParams::setRemotePushNotificationAllowed | ( | bool | allow | ) |

Indicates whether to add to the contact parameters the push notification information.

Parameters

  allow | true to allow remote push notification information, false otherwise.

## ◆ setRoutesAddresses()

LINPHONECXX_PUBLIC linphone::Status linphone::AccountParams::setRoutesAddresses | ( | const std::list< std::shared_ptr< linphone::Address > > & | routes | ) |

Sets a list of SIP route.

When a route is set, all outgoing calls will go to the route's destination if this account is the default one (see Core::setDefaultAccount()).

Warning
  This function cannot be used if linphone_account_params_is_outbound_proxy_enabled is true.

Parameters

  routes | A list of routes.

Returns
  -1 if routes are invalid, 0 otherwise.

## ◆ setServerAddr()

LINPHONECXX_PUBLIC LINPHONECXX_DEPRECATED linphone::Status linphone::AccountParams::setServerAddr | ( | const std::string & | serverAddress | ) |

Sets the proxy address.

Examples of valid sip proxy address are:

Parameters

  serverAddress | The proxy address to set.

Returns
  0 if successful, -1 otherwise.

Deprecated
  01/03/2021 Use setServerAddress() instead.

## ◆ setServerAddress()

LINPHONECXX_PUBLIC linphone::Status linphone::AccountParams::setServerAddress | ( | const std::shared_ptr< linphone::Address > & | serverAddress | ) |

Sets the proxy address.

Examples of valid sip proxy address are:

Parameters

  serverAddress | The proxy as Address to set.

Returns
  0 if successful, -1 otherwise.

## ◆ setTransport()

LINPHONECXX_PUBLIC void linphone::AccountParams::setTransport | ( | linphone::TransportType | transport | ) |

Sets the transport type of the server address.

Parameters

  transport | The TransportType to set.

## ◆ setUseInternationalPrefixForCallsAndChats()

LINPHONECXX_PUBLIC void linphone::AccountParams::setUseInternationalPrefixForCallsAndChats | ( | bool | enable | ) |

If enabled, the international prefix will automaticaly be used for calls and chats.

Parameters

  enable | true to use the international prefix for calls, false otherwise.

The documentation for this class was generated from the following file:

- account_params.hh